indexing
	description: "Project root class"

class
	TEST

create
	make

feature {NONE} -- Initialization

	make is
			-- Run application.		
		do
			store
			retrieve
		end

feature
	store is
			-- Store objects in the database.
		local
			c1, c2 : CAR
			f1, f2 : FERRARI
			glcar : GLIST[CAR]
			glf : GLIST[FERRARI]
			gslcar : GSUBLIST[CAR]
			gslf : GSUBLIST[FERRARI]
			db : IOBJECT_CONTAINER
			closed : BOOLEAN
		do
			db := {DB_4O_FACTORY}.open_file("test_constrained_genericity_eiffel.yap")

			create glcar
			create c1.make ("car1")
			glcar.put(c1)
			db.set(glcar)

			create glf
			create f1.make ("F450")
			glf.put (f1)
			db.set(glf)

			create gslcar
			create c2.make ("subcar2")
			gslcar.put (c2)
			db.set(gslcar)

			create gslf
			create f2.make ("subF430")
			gslf.put (f2)
			db.set(gslf)

			closed := db.close
		rescue
			if (db /= Void) then
				closed := db.close
			end
		end

	retrieve is
			-- Try to access the generic attribute 'item' of GSUBLIST[CAR].
		local
			gslcar, resultgslcar : GSUBLIST[CAR]
			count : INTEGER
			obj : SYSTEM_OBJECT
			car : CAR
			db : IOBJECT_CONTAINER
			results : IOBJECT_SET
			closed : BOOLEAN
		do
			db := {DB_4O_FACTORY}.open_file("test_constrained_genericity_eiffel.yap")

			-- Access count of the first retrieved GSUBLIST[CAR]
			create gslcar
			results := db.get (gslcar)
			if (results /= Void and results.has_next) then
				resultgslcar ?= results.next
				if (resultgslcar /= Void) then
					count := resultgslcar.count  -- OK
					car := resultgslcar.item  -- exception thrown
					io.put_string (car.name)
				end
			end
			closed := db.close
		rescue
			if (db /= Void) then
				closed := db.close
			end
		end
end

