indexing
	description: "Project root class"

class
	TEST

create
	make

feature {NONE} -- Initialization

	make is
			-- Run application.		
		do
			store
			retrieve
			test_conformance
		end

feature
	store is
			-- Store objects in the database.
		local
			c1, c2 : CAR
			f1, f2 : FERRARI
			p1, p2 : POINT
			glcar : GLIST[CAR]
			glf : GLIST[FERRARI]
			glp : GLIST[POINT]
			gslcar : GSUBLIST[CAR]
			gslf : GSUBLIST[FERRARI]
			gslp : GSUBLIST[POINT]
			db : IOBJECT_CONTAINER
			closed : BOOLEAN
		do
			db := {DB_4O_FACTORY}.open_file("test_unconstrained_genericity_eiffel.yap")

			create glcar
			create c1.make ("car1")
			glcar.put(c1)
			db.set(glcar)

			create glf
			create f1.make ("F450")
			glf.put (f1)
			db.set(glf)

			create glp
			create p1.make_with_x_y (1, 2)
			glp.put (p1)
			db.set(glp)

			create gslcar
			create c2.make ("subcar2")
			gslcar.put (c2)
			db.set(gslcar)

			create gslf
			create f2.make ("subF430")
			gslf.put (f2)
			db.set(gslf)

			create gslp
			create p2.make_with_x_y (3, 4)
			gslp.put (p2)
			db.set(gslp)

			closed := db.close
		rescue
			if (db /= Void) then
				closed := db.close
			end
		end

	retrieve is
			-- Try to access the generic attribute 'item' of GLIST[POINT] and GSUBLIST[CAR].
		local
			gslcar, resultgslcar : GSUBLIST[CAR]
			count : INTEGER
			obj : SYSTEM_OBJECT
			car : CAR
			glpoint, resultglpoint : GLIST[POINT]
			pnt : POINT
			db : IOBJECT_CONTAINER
			results : IOBJECT_SET
			closed : BOOLEAN
		do
			db := {DB_4O_FACTORY}.open_file("test_unconstrained_genericity_eiffel.yap")

			-- Access item of the first retrieved GLIST[POINT]
--			create glpoint
--			results := db.get(glpoint)
--			if (results /= Void and results.has_next) then
--				resultglpoint ?= results.next
--				if (resultglpoint /= Void) then
--					pnt := resultglpoint.item  -- exception thrown
--					pnt.output
--				end
--			end

			-- Access count of the first retrieved GSUBLIST[CAR]
			create gslcar
			results := db.get (gslcar)
			if (results /= Void and results.has_next) then
				resultgslcar ?= results.next
				if (resultgslcar /= Void) then
					count := resultgslcar.count  -- OK
					car := resultgslcar.item  -- exception thrown
					io.put_string (car.name)
				end
			end
			closed := db.close
		rescue
			if (db /= Void) then
				closed := db.close
			end
		end

	test_conformance is
			-- Test the conformance rule for generic types.
		local
			car : CAR
			f : FERRARI
			glcar : GLIST[CAR]
			glferrari : GLIST[FERRARI]
			glpoint : GLIST[POINT]
			gslcar : GSUBLIST[CAR]
			gslferrari : GSUBLIST[FERRARI]
			gslpoint : GSUBLIST[POINT]
			obj : SYSTEM_OBJECT
			type : SYSTEM_TYPE
		do
			create glcar
			create glferrari
			create glpoint
			create gslcar
			create gslferrari
			create gslpoint

			obj := glcar
			type := obj.get_type
			io.put_string ("Type of GLIST[CAR]: " + type.full_name)
			io.put_new_line

			obj := glferrari
			type := obj.get_type
			io.put_string ("Type of GLIST[FERRARI]: " + type.full_name)
			io.put_new_line

			obj := glpoint
			type := obj.get_type
			io.put_string ("Type of GLIST[POINT]: " + type.full_name)
			io.put_new_line

			obj := gslcar
			type := obj.get_type
			io.put_string ("Type of GSUBLIST[CAR]: " + type.full_name)
			io.put_new_line

			obj := gslferrari
			type := obj.get_type
			io.put_string ("Type of GSUBLIST[FERRARI]: " + type.full_name)
			io.put_new_line

			obj := gslpoint
			type := obj.get_type
			io.put_string ("Type of GSUBLIST[POINT]: " + type.full_name)
			io.put_new_line

			glcar := glferrari  -- OK
			create car.make ("car in GLIST[FERRARI]")
			glcar.put (car)  -- OK
			--f := glcar.item  -- compile time error

			--glcar := glpoint  -- Error: Source of assignment does not conform to target.
			glcar := gslcar     -- OK
			--glpoint := gslpoint -- OK
			glcar := gslferrari -- OK
		end
end

-- Console output:
--Type of GLIST[CAR]: RootCluster.Impl.GlistReference
--Type of GLIST[FERRARI]: RootCluster.Impl.GlistReference
--Type of GLIST[POINT]: RootCluster.Impl.GlistPoint
--Type of GSUBLIST[CAR]: RootCluster.Impl.GsublistReference
--Type of GSUBLIST[FERRARI]: RootCluster.Impl.GsublistReference
--Type of GSUBLIST[POINT]: RootCluster.Impl.GsublistPoint

